% KeCoDe_DECODER_ACHROM decompress the files encoded with KeCoDe_ENCODER_ACHROM
%
% Given the folder and the name of the file to decompress, the program identifies the
% required decoder to recover the image.
%
% SYNTAX:
%
%   im=KeCoDe_decoder_achrom('folder','name')
%
%   Input
%       'folder'   = String with the folder containing the file to decompress
%       'name'     = String with the name of the file to decompress (do not include the '.zip' extension!)
%                    Note that the names have to include the algorithm identifiers
%                    given by KeCoDe_ENCODER_ACHROM.M.
%

function ImR = KeCoDe_decoder(directorio,fichero)
you_are_here=pwd;
cd(directorio);
if(~isempty(findstr(fichero,'cte_svr')) || ~isempty(findstr(fichero,'robinson03')) || ~isempty(findstr(fichero,'gomez05')))
    K = kernel2d_variance(16,1);
    ImR = svr_dct_decoder(K,directorio,fichero);
elseif(~isempty(findstr(fichero,'camps08')))
    K = kernel2d_variance(16,1);
    exponente = 1;
    ImR = svr_nl_decoder(K,exponente,directorio,fichero);
elseif(~isempty(findstr(fichero,'nl2_svr')))
    K = kernel2d_variance(16,1);
    exponente = 2;
    ImR = svr_nl_decoder(K,exponente,directorio,fichero);
elseif(~isempty(findstr(fichero,'jpeg91')))
    ImR = jpeg91_decoder(directorio,fichero);
elseif(~isempty(findstr(fichero,'malo99')))
    ImR = malo99_decoder(directorio,fichero);
elseif(~isempty(findstr(fichero,'malo06')))
    exponente = 1;
    ImR = malo06_decoder(exponente,directorio,fichero);
elseif(~isempty(findstr(fichero,'malo06_2')))
    exponente = 2;
    ImR = malo06_decoder(exponente,directorio,fichero);
else
    disp('The decoding algorithm cannot be obtained from the file name!');
end
cd(you_are_here);
