
%
% KeCoDe_DECODER_COLOR decompress the files encoded with KeCoDe_ENCODER_COLOR
%
% Given the folder and the name of the file to decompress, the program identifies the
% required decoder to recover the image.
%
% SYNTAX:
%
%   im=KeCoDe_decoder_color('folder','name')
%
%   Input
%       'folder'   = String with the folder containing the file to decompress
%       'name'     = String with the name of the file to decompress (do not include the 'zip' extension!)
%                    Note that the names have to include the algorithm identifiers
%                    given by KeCoDe_ENCODER_COLOR.M.
%

function ImR = KeCoDe_decoder_color(directorio,fichero)
normaliz = 1;
To = [100 0 0];
dUmax = 40;
dVmax = 43;
niveles = 1;
cd(directorio);
if(~isempty(findstr(fichero,'jpeg91_c')))
    ImR = jpeg91_c_decoder(normaliz,To,dUmax,dVmax,directorio,fichero,niveles);
elseif(~isempty(findstr(fichero,'gutierrez09_c')))
    K=kernel2d_variance(16,1);
    exponentes=[2 2 2];
    tipo_alfa=1;
    ImR = svr_nl_c_decoder_cs(normaliz,To,dUmax,dVmax,K,exponentes,tipo_alfa,directorio,fichero);
else
    disp('The decoding algorithm cannot be obtained from the file name!');
end
