
function [ristra,dctq,TheRealCode,ImR,DC] = epifanio03_decoder(directorio,fichero)
trayfich = 'estarereB';

load(trayfich);
Lb = 16;
Li = 256;

cd(directorio)
unzip([fichero '.zip']);
ristra = read_code_epifanio03([fichero '.bin']);

delete([fichero '.bin']);
TheCode = zeros(256,255);

normaliz = [1 0];
extr_err = ristra(1:2);
QE = reshape(ristra(3:2+256),16,16);
uCP = ristra(259);

ristra = ristra(260:end);

[TheCode] = inv_rle(ristra);

NumNiv = 2^uCP;
M = 10;

TheRealCode = TheCode * M / NumNiv;

Nc = round(0.9 * 40);
qe = (extr_err(2) - extr_err(1)) * QE / (Nc - 1) + extr_err(1);

Lmq = iimdpcm(qe,1,100);
DC = 16 * Lmq;

fprintf('Recovering the image:\n');
fprintf('  Inverting from r to dct\n');
z = 1;
invgrad = inv(grad);
for i = 1:Lb:(Li-1)
    for j = 1:Lb:(Li-1)

        signo1 = sign(TheRealCode(z,:)');
        signo1(signo1 == 0) = 1;
        signo1 = [1; signo1];

        irrq = signo1 .* adctm + signo1 .* (invgrad * V2 * [0; abs(TheRealCode(z,:)')]);
        irrq = dezigzag(irrq);

        dc(2:Lb,1) = irrq(2:Lb,1) * DC(round(i/Lb)+1,round(j/Lb)+1) / 2;
        dc(1,2:Lb) = irrq(1,2:Lb) * DC(round(i/Lb)+1,round(j/Lb)+1) / 2;
        dc(2:Lb,2:Lb) = irrq(2:Lb,2:Lb) * DC(round(i/Lb)+1,round(j/Lb)+1) / 4;
        dc(1,1) = DC(round(i/Lb)+1,round(j/Lb)+1);

        dctq(i:(i+(Lb-1)),j:(j+(Lb-1))) = dc;
        z = z + 1;
    end
end
fprintf('  Inverting from dct to spatial domain\n');
ImR = real(idct2r(dctq,4));

