
function [ImR] = epifanio03_decoder_v2(directorio,fichero,signos_dct)
M = 10;
trayfich = 'estarereB';

load(trayfich);
invgrad=inv(grad);
Lb = 16;
Li = 256;

cd(directorio)
unzip([fichero '.zip']);
ristra = read_code_epifanio03([fichero '.bin']);

delete([fichero '.bin']);
TheCode = zeros(256,255);

extr_err = ristra(1:2);
size(extr_err)
QE = reshape(ristra(3:2+256),16,16);
size(QE)
uCP = ristra(259)

ristra = ristra(260:end);

[TheCode] = inv_rle(ristra);

TheCode = [zeros(Li,1) TheCode];

TheRealCode = TheCode .* M/(2^uCP);

signos = sign(TheRealCode);
signos(signos == 0) = 1;
mis_signos = signos;

Nc = round(0.9 * 40);
qe = (extr_err(2) - extr_err(1)) * QE / (Nc - 1) + extr_err(1);

Lmq = iimdpcm(qe,1,100);

fprintf('Recovering the image:\n');
fprintf('  Inverting from r to dct\n');
z = 1;
dctc = zeros(Li,Li);
for i = 1:Lb:Li
    for j = 1:Lb:Li-1

        bloque = TheRealCode(z,:)';

        signo_b = signos(z,:)';

        inversion = signos_dct(z,:)' .* adctm + signos_dct(z,:)' .* (invgrad * V2 * bloque);
        bloque_inv = dezigzag(inversion);

        dctc(i:i+Lb-1,j:j+Lb-1) = bloque_inv;
        z = z+1;
    end
end
fprintf('  Inverting from dct to spatial domain\n');

dcti = icontrast_2(dctc,Lmq,4,[1 0]);

ImR = real(idct2r(dcti,4));
