% QREREDCT (uniform) quantization of the linear reretransformada
% of the image blocks given, M may be a
% scalar or vector giving the maximum in each coefficient
% If it is a scalar, the same maximum gets on all coef.
% To get the maximum with those obtained in sacaesta, use maxcoef
% (H2 disregarding signs)
%
% USE: [imq, codq, E, Hi] = qreredct (im, B, 'c: \ tmp \ estarere' maximo_r'');
% Hi: Entropy computed earliest form, E: entropy calculated according e2 entroprova: all blocks

function [ristra,xdct2,prueba,DC] = epifanio03_encoder(imag,B,directorio,fichero)

trayfich = 'estarereB';

M = 10;

tam = size(imag);

load(trayfich);

resol = 4;
H = 0;
Hi = 0;

tamM = size(M);

tam = tam(1);
pto = [tam tam]/2;
lados = [tam tam];
lcuan = tam/(2^resol);
posai = pto-round(lados/2);
posbd = pto+round(lados/2);
coorcuanai = floor([(posai(1)-1)/lcuan+1 (posai(2)-1)/lcuan+1]);
coorcuanbd = floor([(posbd(1)-1)/lcuan+1 (posbd(2)-1)/lcuan+1]);

if coorcuanai(1)<1
    coorcuanai(1)=1;
end
if coorcuanai(2)<1
    coorcuanai(2)=1;
end
if coorcuanbd(1)>(2^resol)
    coorcuanbd(1)=2^resol;
end
if coorcuanai(2)>(2^resol)
    coorcuanbd(2)=2^resol;
end

adctfglob = zeros(size(imag));

xdct2 = dct2r(imag,resol);
[xdctf,xLm] = contrast_2(xdct2,resol,[1 0]);
adct = abs(xdctf);
sdct = sign(xdct2);
sdct(sdct==0) = 1;

W = 1;

val_r = 100;

e = imdpcm(xLm,W,val_r);

Nc = round(0.9 * 40);

me = mini(e);
Me = maxi(e);

extr_err = [me Me];

QE = round((Nc -1) * (e - me) / (Me - me));

DC = xLm*16;
L = V2'*grad;

dctq = zeros(tam,tam);
codq = dctq;

codigazo = [];
prueba = zeros(256,255);
bloquecito = 1;

for ii=coorcuanai(1):coorcuanbd(1)

    for jj=coorcuanai(2):coorcuanbd(2)

        iii = (ii-1)*lcuan+ceil(lcuan/2);
        jjj = (jj-1)*lcuan+ceil(lcuan/2);
        cub = sacasub(adct,[iii jjj],[lcuan lcuan],0);
        zcub = zigzag(cub);
        tzcub = L*(zcub) + consta;

        tzcub = tzcub(2:end);

        cod = round(2^B * tzcub ./ M);

        rrc = cod .* M / (2^B);

        signo1 = zigzag(sacasub(sdct,[iii jjj],[lcuan lcuan],0));
        signo1 = signo1(2:end);

        codigon = signo1 .* rrc;
        codigonint = signo1 .* abs(cod);
        prueba(bloquecito,:) = codigon;

        [codigo,ceros] = rle2(codigonint);
        codigazo = [codigazo codigo ceros];

        bloquecito = bloquecito + 1;

    end
end

ristra = [extr_err(:)' round(QE(:))' B round(codigazo)];

cd(directorio);
save_code_epifanio03(ristra,[fichero '.bin']);

zip(fichero,[fichero '.bin']);

delete([fichero '.bin']);
