
% Unzip a file created with 'malo06_encoder' and retrieve the image
%
% USE: [ImR] = malo06_decoder (exponente, directorio, fichero)
%
% Where:
%
% Exponente -> You can take the values ​​1 or 2 and must match the
% used in malo06_encoder
% Directorio -> Where is the file to decompress
% Fichero -> zip file name (without the extension) to decompress.

function [ImR] = malo06_decoder(exponente,directorio,fichero)

Lb = 16;
Li = 256;

cd(directorio)
unzip([fichero '.zip']);
ristra = read_code_malo06([fichero '.bin']);

delete([fichero '.bin']);

TheCode = zeros(256,255);

normaliz = [3 ristra(1)];
extr_err = ristra(2:3);
QE = reshape(ristra(4:3+256),16,16);
uCP = ristra(260);

ristra = ristra(261:end);

[TheCode] = inv_rle(ristra);

NumNiv = 2^uCP;
MM = 0.8;

TheRealCode = TheCode * MM / NumNiv;

Nc = round(0.9 * 40);
qe = (extr_err(2) - extr_err(1)) * QE / (Nc - 1) + extr_err(1);

Lmq = iimdpcm(qe,1,100);

aa = zeros(Lb);
[h,kk1,kk2,gamm] = constrains_resp(exponente,1);
[h_a,r,grad,alfa,beta] = respue5(aa,kk1,kk2,gamm,h,0);

fprintf('Recovering the image:\n');
fprintf('  Inverting from r to dct\n');

z = 1;

dctc1 = zeros(Li,Li);
Db = diag(beta);

for i=1:Lb:(Li-1)
    for j=1:Lb:(Li-1)

        r = TheRealCode(z,:)';

        signos = r < 0;

        r = [0; abs(r)];

        Dr = diag(r);

        ac = ((inv(eye(size(h)) - Dr*h) * Db*r) .^ (1/gamm)) ./ alfa;

        ac = ac(2:end);
        ac = ac .* (signos == 0) - ac .* (signos == 1);
        ac = [0; ac];

        ac = dezigzag(ac);

        dctc1(i:(i+(Lb-1)),j:(j+(Lb-1))) = ac;

        z = z+1;
    end
end

fprintf('  Inverting from dct to spatial domain\n');

dctc1i = icontra2(dctc1,Lmq,4,normaliz);

ImR = real(idct2r(dctc1i,4));

