% It decompress a file created using 'malo99_encoder' and it recovers the image
%
% USE: [ImR] = malo99_decoder(directorio,fichero)
%
% where:
%
% directorio -> Folder where the file to decompress is
% fichero    -> Name of the .zip file (whithout extension) to decompress

function [ImR] = malo99_decoder(directorio,fichero)
Lb = 16;
Li = 256;

cd(directorio)
unzip([fichero '.zip']);
ristra = read_code_malo99([fichero '.bin']);

delete([fichero '.bin']);
TheCode = zeros(256,255);

norm = [3 ristra(1)];
extr_err = ristra(2:3);
QE = reshape(ristra(4:3+256),16,16);
B = ristra(260);

ristra = ristra(261:end);

[TheCode] = inv_rle(ristra);

NumNiv = 2^B;
MM = 0.8;

TheRealCode = TheCode * MM / NumNiv;

Nc = round(0.9 * 40);
qe = (extr_err(2) - extr_err(1)) * QE / (Nc - 1) + extr_err(1);

Lmq = iimdpcm(qe,1,100);

fprintf('Recovering the image:\n');
fprintf('  Inverting from r to dct\n');
z = 1;
dctc1 = zeros(Li,Li);
for i = 1:Lb:(Li-1)
    for j = 1:Lb:(Li-1)

        b = TheRealCode(z,:)';
        b = [0; b];
        b = dezigzag(b);

        dctc1(i:(i+(Lb-1)),j:(j+(Lb-1))) = b;
        z = z + 1;
    end
end

dctc1i = icontra2(dctc1,Lmq,4,norm);

ImR = real(idct2r(dctc1i,4));
