% QREREDCT  (uniform) quantization of the linear reretransformada
% of the blocks of the image that are passed, M may be a
% scalar or vector giving the maximum in each coefficient
% If it is a scalar, the same maximum gets on all coef.
% To get the maximum with those obtained in sacaesta, use maxcoef
% (H2 disregarding signs)
%
% USE: [imq,codq,E,Hi]=qreredct(im,B,'c:\tmp\estarere',maximo_r'');
% Hi: Entropy computed earliest form, E: entropy calculated according e2 entroprova: all blocks

function [xdct2,dctq,imq]=qreredct_v2(imag,B,trayfich,M)

tam=size(imag);

load(trayfich);

resol=4;
H=0;
Hi=0;

tamM=size(M);
if tamM==[1 1]
    M=M*ones(256,1);
end

tam=tam(1);
pto=[tam tam]/2;
lados=[tam tam];
lcuan=tam/(2^resol);
posai=pto-round(lados/2);
posbd=pto+round(lados/2);
coorcuanai=floor([(posai(1)-1)/lcuan+1 (posai(2)-1)/lcuan+1]);
coorcuanbd=floor([(posbd(1)-1)/lcuan+1 (posbd(2)-1)/lcuan+1]);

if coorcuanai(1)<1
    coorcuanai(1)=1;
end
if coorcuanai(2)<1
    coorcuanai(2)=1;
end
if coorcuanbd(1)>(2^resol)
    coorcuanbd(1)=2^resol;
end
if coorcuanai(2)>(2^resol)
    coorcuanbd(2)=2^resol;
end

adctfglob=zeros(size(imag));

xdct2=dct2r(imag,resol);
[xdctf,xLm]=contrast_2(xdct2,resol,[1 0]);
adct=abs(xdctf);
sdct=sign(xdct2);
sdct(sdct==0)=1;

DC = xLm*16;
L = V2'*grad;

dctq=zeros(tam,tam);
codq=dctq;
invgrad=inv(grad);

codigazo = zeros(256,256);
bloquecito = 1;

for ii=coorcuanai(1):coorcuanbd(1)

    for jj=coorcuanai(2):coorcuanbd(2)

        iii=(ii-1)*lcuan+ceil(lcuan/2);
        jjj=(jj-1)*lcuan+ceil(lcuan/2);
        cub=sacasub(adct,[iii jjj],[lcuan lcuan],0);
        zcub=zigzag(cub);
        tzcub=L*(zcub)+consta;

        cod=round(2^B*tzcub./M);

        cod(1)=0;

        aux2=((cod==Inf)|(cod==-Inf));
        cod(aux2)=0;

        rrc=cod.*M/(2^B);

        signo1=zigzag(sacasub(sdct,[iii jjj],[lcuan lcuan],0));

        codigo = signo1.*rrc;
        codigazo(bloquecito,:) = codigo;

        irrq=signo1.*adctm+signo1.*(invgrad*V2*rrc);

        irrq=dezigzag(irrq);

        dc(2:lcuan,1)=irrq(2:lcuan,1)*DC(ii,jj)/2;
        dc(1,2:lcuan)=irrq(1,2:lcuan)*DC(ii,jj)/2;
        dc(2:lcuan,2:lcuan)=irrq(2:lcuan,2:lcuan)*DC(ii,jj)/4;
        dc(1,1)=DC(ii,jj);

        dctq=metesub(dctq,[iii jjj],dc);
        codq=metesub(codq,[iii jjj],dezigzag(cod));

        bloquecito = bloquecito + 1;
    end
end

imq=idct2r(dctq,resol);

Hi=Hi/(256*256);

e2=0;
n_im=1;
f=linspace(0,32,16);
F=repmat(simrev(f),[16 16*n_im]);
for i=1:length(f)
    if i==1
        m0=(F==f(i));
        mue1=codq(m0);

    else
        m0=(F>f(i-1) & F<=f(i));

        mue1=codq(m0);
        e2=e2+sum(sum(m0(1:16,1:16)))*entropiv(mue1);
    end

end

E=e2/255;

