% It decompress a file created using 'svr_dct_encoder' and it recovers the image
%
% USE: [ImR] = svr_dct_decoder(H,directorio,fichero)
%
% where:
%
% H          -> Regression Kernel
% directorio -> Folder where the file to decompress is
% fichero    -> Name of the .zip file (whithout extension) to decompress

function [ImR] = svr_dct_decoder(H,directorio,fichero)
Lb = 16;
Li = 256;

cd(directorio)
unzip([fichero '.zip']);
ristra = read_code_svr_dct([fichero '.bin']);

delete([fichero '.bin']);
TheCode = zeros(256,255);

normaliz = [3 ristra(1)];
extr_err = ristra(2:3);
QE = reshape(ristra(4:3+256),16,16);
bits = ristra(260) / 10;

ristra = ristra(261:end);

[TheCode] = inv_rle(ristra);

NumNiv = 2^bits;
MM = 0.8;

TheRealCode = TheCode * MM / NumNiv;

N = round(0.9 * 40);
qe = (extr_err(2) - extr_err(1)) * QE / (N - 1) + extr_err(1);

Lmq = iimdpcm(qe,1,100);

fprintf('Recovering the image:\n');
fprintf('  Inverting from SVM weights to dct\n');
z=1;
dctc1 = zeros(Li,Li);

for i=1:Lb:Li
    for j=1:Lb:Li

        y = H * TheRealCode(z,:)';

        y = abs(y);
        signosr = TheRealCode(z,:) < 0;
        signosr = signosr';
        y = y.*(signosr == 0) - y.*(signosr > 0);
        y = [0; y];
        A = dezigzag(y);
        dctc1(i:(i+(Lb-1)),j:(j+(Lb-1))) = A;

        z = z+1;
    end
end
fprintf('  Inverting from dct to spatial domain\n');

dctc1i = icontra2(dctc1,Lmq,4,normaliz);

ImR = real(idct2r(dctc1i,4));
