% It decompress a file created using 'svr_nl_encoder' and it recovers the image
%
% USE: [ImR] = svr_nl_decoder(K,exponente,directorio,fichero)
%
% where:
%
% K          -> Regression Kernel
% exponente  -> Exponent employed in the compression (1 or 2)
% directorio -> Folder where the file to decompress is
% fichero    -> Name of the .zip file (whithout extension) to decompress

function [ImR] = svr_nl_decoder(K,exponente,directorio,fichero)
Lb = 16;
Li = 256;

cd(directorio)
unzip([fichero '.zip']);
ristra = read_code_svr_nl([fichero '.bin']);

delete([fichero '.bin']);
TheCode = zeros(256,255);

normaliz = [3 ristra(1)];
extr_err = ristra(2:3);
QE = reshape(ristra(4:3+256),16,16);
bits = ristra(260);

ristra = ristra(261:end);

[TheCode] = inv_rle(ristra);

NumNiv = 2^bits;
MM = 0.8;

TheRealCode = TheCode * MM / NumNiv;

N = round(0.9 * 40);
qe = (extr_err(2) - extr_err(1)) * QE / (N - 1) + extr_err(1);

Lmq = iimdpcm(qe,1,100);
DC = 16 * Lmq;
DC = DC';
DC = DC(:);

cero = 1;
aa = zeros(Lb);
[h,alpha,beta,gamm] = constrains_resp(exponente,cero);
[h_a,r,GR,alfa2d,beta2d] = respue5(aa,alpha,beta,gamm,h,0);

fprintf('Recovering the image:\n');
fprintf('  Inverting from SVM weights to the non-linear domain\n');
fprintf('  Inverting from the non-linear domain to DCT\n');
z = 1;
Db = diag(beta2d);
Identidad = eye(size(h));

TheRealCode2 = TheRealCode';

for i=1:Lb:(Li-1)
    fprintf('.');
    for j=1:Lb:(Li-1)

        r_recon = K * TheRealCode2(:,z);
        signosr = r_recon < 0;
        r_recon = [0; abs(r_recon)];

        Dr = diag(r_recon);
        ac = ((inv(Identidad-Dr*h)*Db*r_recon).^(1/gamm))./alfa2d;

        ac_c = ac(2:end);
        acs = ac_c.*(signosr==0) - ac_c.*(signosr>0);
        acs = [0;acs];
        acs = dezigzag(acs);

        acs(1,1) = DC(z);
        dctc1(i:(i+(Lb-1)),j:(j+(Lb-1))) = acs;
        z = z+1;
    end
end
fprintf('  Inverting from DCT to spatial domain\n');

dctc1i = icontra2(dctc1,Lmq,4,normaliz);

ImR = real(idct2r(dctc1i,4));
