
function [Results] = epifanio03_ucp_distortion(Im,param,B_inicial,variable);

Im = double(Im);

fich='estarereB';

max_r=10;

Results=[];

contador = 0;

for parametro = param

     disp(['Adjustment of uCP to reach desired ' variable ':   ' num2str(parametro)]);

    switch(variable)
        case 'SNR', parametro_actual = 1; umbral = 0.05;
        case 'MSE', parametro_actual = 1; umbral = 0.5;
        case 'SSIM', parametro_actual = 0; umbral = 0.001;
        case 'MPE lineal', parametro_actual = 100; umbral = 0.01;
        case 'MPE no lineal', parametro_actual = 100; umbral = 0.01;
        case 'MPE no lineal JMLR', parametro_actual = 100; umbral = 0.1;
    end

    iter = 0;

    B = 0;

    porcentaje = 1;

    if(isequal(variable,'SSIM'))
        sentido = 1;
    else
        sentido = 0;
    end

    no_results = 0;

    l_min = 0;
    l_max = 100000;

    while(abs(parametro - parametro_actual) > umbral) & (iter < 30)

        iter = iter + 1;

        if(iter ~= 1 & iter ~= 2)
            switch(variable)
                case 'SNR',
                    [B, l_min, l_max, porcentaje, sentido] = fitting_uCP_SSIM(parametro, parametro_actual, B, l_min, l_max, porcentaje, sentido);
                case 'MSE',
                    [B, l_min, l_max, porcentaje, sentido] = fitting_uCP(parametro, parametro_actual, B, l_min, l_max, porcentaje, sentido);
                case 'SSIM',
                    [B, l_min, l_max, porcentaje, sentido] = fitting_uCP_SSIM(parametro, parametro_actual, B, l_min, l_max, porcentaje, sentido);
                case 'MPE lineal',
                    [B, l_min, l_max, porcentaje, sentido] = fitting_uCP(parametro, parametro_actual, B, l_min, l_max, porcentaje, sentido);
                case 'MPE no lineal',
                    [B, l_min, l_max, porcentaje, sentido] = fitting_uCP(parametro, parametro_actual, B, l_min, l_max, porcentaje, sentido);
                case 'MPE no lineal JMLR',
                    [B, l_min, l_max, porcentaje, sentido] = fitting_uCP(parametro, parametro_actual, B, l_min, l_max, porcentaje, sentido);
            end
        end

        [imq,codq,E,Hi]=qreredct(Im,B,fich,max_r);
        ImR = imq;

        switch(variable)
            case 'SNR',
                [mse,SNRi] = emse2(Im,ImR);
                fprintf('   It. =
                parametro_actual = SNRi;
            case 'MSE',
                [mse,SNRi] = emse2(Im,ImR);
                fprintf('   It. =
                parametro_actual = mse;
            case 'SSIM',
                esesim = ssim_index(Im,ImR);
                fprintf('   It. =
                parametro_actual = esesim;
            case 'MPE lineal',
                [MSE,d_l,dx0,MPEx0,MPEoo0,MPEexpesp0] = disdis_lineal(Im,ImR,2,[3 mean(mean(Im))],2,2);
                mpelin = d_l;
                fprintf('   It. =
                parametro_actual = mpelin;
            case 'MPE no lineal',
                [MSE,d,dx,MPEx,MPEoo,MPEexpesp] = disdis7(Im,ImR,[3 mean(mean(Im))],2,1,2,2);
                mpenonlin= d;
                fprintf('   It. =
                parametro_actual = mpenonlin;
            case 'MPE no lineal JMLR',
                [MSE,d,dx,MPEx,MPEoo,MPEexpesp] = disdis7(Im,ImR,[3 mean(mean(Im))],1,0.5,2,2);
                mpenonlinJMLR = d;
                fprintf('   It. =
                parametro_actual = mpenonlinJMLR;
        end

        if(~isequal(variable,'SSIM') & (iter == 1) & (parametro - parametro_actual > 0) & (B == 0))
            no_results = 1;
            disp('No se puede ajustar el uCP para esta distorsion');
            break;

        elseif(isequal(variable,'SSIM') & (iter == 1) & (parametro - parametro_actual < 0) & (B == 0))
            no_results = 1;
            disp('No se puede ajustar el uCP para esta distorsion');
            break;

        elseif((iter == 1) & (abs(parametro - parametro_actual) <= umbral) & (B == 0))
            no_results = 1;
            disp('No se puede ajustar el uCP para esta distorsion');
            break;

        elseif(iter == 1)
            B = B_inicial;
        end
    end

    if(no_results == 0)

        contador = contador + 1;

        H = Hi;

        Results(contador).uCP = B;
        Results(contador).Image = ImR;
        Results(contador).Entropy = H;

        switch(variable)
            case 'SNR',
                Results(contador).SNR = SNRi;
            case 'MSE',
                Results(contador).MSE = mse;
            case 'SSIM',
                Results(contador).SSIM = esesim;
            case 'MPE lineal',
                Results(contador).MPE_lineal = mpelin;
            case 'MPE no lineal',
                Results(contador).MPE_no_lineal = mpenonlin;
            case 'MPE no lineal JMLR',
                Results(contador).MPE_no_lineal_JMLR = mpenonlinJMLR;
        end
    end
end
