%
% RESPUE_LINEAL calculates the linear response to local DCT2D
% (Expressed in contrast)
%
% DCTN (f) = CSF (f) DCT (f)
%
% Inputs:
% CSF (only frequency dependent, i.e. as in naka100.m)
%
% Returns:
%
% The response, Resp
% The CSF parameter in matrix form, CSF2D
%
% NOTE: It is assumed that the block gets into the function is already expressed in
% contrast (see CONTRAST)
%
% USE:
% [Resp,CSF2D]=respue_lineal(dctinic,CSF)

function [R,CSF2D]=respue_lineal(dctinic,k1)

tam=size(dctinic);
tam=tam(1);
lados=[tam tam];

lcuan=lados(1);

k1=simrev(k1);
k1=zigzag(k1);

alfa=k1;

cub=dctinic;

cub=zigzag(cub);

cub=abs(cub);

R=k1.*cub;
R(1)=sqrt(cub(1));

R=dezigzag(R);

CSF2D=k1;
