% 'ENTROPY' calculates the entropy of an isolated matrix referring it
% to its own statistics, i.e. account all the different values
% (Xi) and the number of occurrences (ni) and calculate the probability
% of each xi as Pi = ni / N.
% At the end makes the corresponding summation:
%             _
%            |
% Entropy =  | P (x) log2 (P (x)) dx
%            |
%           -
%
% USE: [e] = entropia(a);

function [e,ta]=entropia(a)

n=size(a);
k=1;

for i=1:n(1)
    for j=1:n(2)
       dato=a(i,j);
       if (i==1)&(j==1)
          ta=[1 dato 1];
       else
          valores=ta(:,2);
          condicion=sum(((valores-dato)==0));
          if condicion>0
             indice=find((valores-dato)==0);
             ta(indice,3)=ta(indice,3)+1;

          else
             k=k+1;
             ta(k,:)=[k dato 1];

          end
       end
   end
end

P=ta(:,3)/(n(1)*n(2));
LP=-log(P)/log(2);

e=sum(P.*LP);

