
% PROPOR computes de proportion of volume in the region R_a contained in R_b
% being R_a y R_b n-dimensional parallelepipeds with the same orientation.
% Paralelepipeds are defined by its boundaries in each dimension.
%
% USE: proporcion=propor([xma1 xMa1;xma2 xMa2;....;xman xMan],[xmb1 xMb1;xmb2 xMb2;....;xmbn xMbn]);

function porcien=propor(ra,rb);

n=size(ra);
n=n(1);

for i=1:n
    limA=ra(i,:);
    limB=rb(i,:);
    if ((limA(1)>=limB(1))&(limA(1)<=limB(2)))&((limA(2)>=limB(1))&(limA(2)<=limB(2)))
       l(i)=limA(2)-limA(1);
    elseif ((limA(1)>=limB(1))&(limA(1)<=limB(2)))&(limA(2)>=limB(2))
       l(i)=limB(2)-limA(1);
    elseif ((limA(2)>=limB(1))&(limA(2)<=limB(2)))&(limA(1)<=limB(1))
       l(i)=limA(2)-limB(1);
    elseif ((limB(1)>=limA(1))&(limB(1)<=limA(2)))&((limB(2)>=limA(1))&(limB(2)<=limA(2)))
       l(i)=limB(2)-limB(1);
    else
       l(i)=0;
    end
end
volint=prod(l);
volA=prod(ra(:,2)-ra(:,1));
porcien=volint/volA;
