
function [Results]=svr_dct(Im,bits,entropiad,epsilonv,H,perfil,sepsigno)

Lb=16;
Li=length(Im);

R=1:(Lb*Lb-1); R=R(:);
N=length(R);

C=40000;
D = ones(1,N); D = D(:);

Results=[];

for x=1:length(entropiad)

    epsilon=epsilonv(x);
    ImR=rand(Li);

    entropiat=10;
    umbral=0.005;
    iter=0;

    while (abs(entropiad(x)-entropiat)> umbral) & (iter < 30)
        signoscoefs=[];

        betasc=[];
        BtC=[];
        Coef11=[];
        SVs=[];
        lSVs=[];

        fprintf('Training all the blocks of the local DCT');

        for i=1:Lb:Li
            fprintf('.');
            for j=1:Lb:Li

                B=Im(i:(i+(Lb-1)),j:(j+(Lb-1)));
                B=dct2(B);
                Coef11=[Coef11;B(1,1)];
                B=zigzag(B);
                B=B(2:end);
                BtC=[BtC;B'];

                bitsig=getsign(B,Lb);
                signoscoefs = [signoscoefs; bitsig];

                [nsv,beta,bias] = irwls_pd_svr_nobias(R,abs(B),H,C,D,epsilon,perfil);

                betasc=[betasc;beta'];

            end
        end

        fprintf('\n');

        MM=max(max(abs(betasc))); MM=MM/4;

        if (MM>0)

           NumNiv = 2^bits;

           betascr = round( NumNiv * betasc/MM)*MM/NumNiv;

           signos = zeros(size(signoscoefs));
           signos(logical(betascr~=0))=signoscoefs(logical(betascr~=0));

           entropc = [];
           entrops = [];

           codigon = betascr.*(~signos) - betascr.*(signos);
           for i=1:Lb^2

               if sepsigno==0
                   codigo = betascr(i,:).*(~signos(i,:)) - betascr(i,:).*(signos(i,:));
                   [rlePesos,repCeros] = rle2(codigo);
                   entropc = [entropc length(rlePesos)*entropiv(rlePesos)+length(repCeros)*entropiv(repCeros)];
                   entrops = 0;
               else

                   [rlePesos,repCeros] = rle2(betascr(i,:));
                   entropc = [entropc length(rlePesos)*entropiv(rlePesos)+length(repCeros)*entropiv(repCeros)];

                   [rlePesoss,repCeross] = rle2(signos(i,:));
                   entrops = [entrops length(rlePesoss)*entropiv(rlePesoss)+length(repCeross)*entropiv(repCeross)];
               end;

           end

           entropcn = sum(entropc)/Li^2;
           entropsn = sum(entrops)/Li^2;

           entropiat= entropcn + entropsn;
           iter=iter+1;

           epsilon = variacion_epsilon(entropiad, entropiat, epsilon);
           fprintf('   It. =

        else
           entropiat=0;
           epsilon = epsilon/2;
           fprintf('   It. =

        end
    end

    z=1;

    for i=1:Lb:Li
        for j=1:Lb:Li

            y=H*betascr(z,:)';

            y=obtainsign(y, signos, Lb,z);

            A=dezigzag([Coef11(z);y]);

            A=idct2(A);

            ImR(i:(i+(Lb-1)),j:(j+(Lb-1)))=A;

            z=z+1;

        end
    end

    [mse,SNRi]=emse2(Im,ImR);
    esesim = ssim_index(Im,ImR);

    [MSE,d_l,dx0,MPEx0,MPEoo0,MPEexpesp0] = disdis_lineal(Im,ImR,2,[3 mean(mean(Im))],2,2);
    mpelin = d_l;

    [MSE,d,dx,MPEx,MPEoo,MPEexpesp] = disdis7(Im,ImR,[3 mean(mean(Im))],1,0.5,2,2);
    mpenonlinJMLR= d;

    [MSE,d,dx,MPEx,MPEoo,MPEexpesp] = disdis7(Im,ImR,[3 mean(mean(Im))],2,1,2,2);
    mpenonlin= d;

    Results = [Results;struct('bits',bits,'epsilon',epsilon,'NumNiv',NumNiv, ...
                              'MSE',mse,'SNR',SNRi,'MPElin',mpelin,...
                              'MPEnonlinJMLR',mpenonlinJMLR,'MPEnonlin',mpenonlin,...
                              'ssim',esesim,'Entropy',entropiat, ...
                              'entropiasig',entropsn,'entropiapes',entropcn,'Image',ImR,...
                              'VecSopCuant',betascr,'VecSop',betasc,'Perfil',epsilon./perfil,...
                              'Kernel',H,'C',C,'Code',codigon)];

end

