% IMDPCM invierts the image codification given a spatial DPCM
% estimating each pixel given a lineal combination of the neighbours
% (in a neighbouthood of N^2 size).
%
%                         /  N                  \
%   est(I([i,j]))= round |  sum w(d)*I([i,j]-d)  |
%                         \ d=1                 /
%
% It gives back the prediction error for each point:
%
%  e([i,j])=I(i,j)-est(I([i,j]))
%
% Given this error, the original signal can be reconstructed using IIMDPCM
%
% USE: e=imdpcm(I,[w(1) w(2) w(3)...],valor_relleno);

function e=imdpcm(I,w,val_relleno)

l=length(w);
s=size(I);
a=val_relleno*ones(l,s(2)+2*l);
i=val_relleno*ones(s(1),l);
d=val_relleno*ones(s(1),l);
b=val_relleno*ones(l,s(2)+2*l);
I=[a;i I d;b];
estI=I;
e=I;

W=simrev([w(1) w]);
W(1,1)=0;
W=rot90(W,2);
W=W/sum(sum(W));

for i=l+1:s(1)+l

    for j=l+1:s(2)+l
        bloc=I(i-l:i,j-l:j);
        estI(i,j)=round(sum(sum(W.*bloc)));
        e(i,j)=I(i,j)-estI(i,j);
    end
end
e=sacasub(e,[s(1)/2+l s(2)/2+l],[s(1) s(2)],0);
