
% sentido = 1 -> Increassing epsilon (i.e. increasing the distortion parameter)
% sentido = 0 -> Decreassing epsilon (i.e. decreasing the distortion parameter)
% l_min       -> Lower epsilon limit
% l_max       -> Upper epsilon limit

function [epsilon, l_min, l_max, porcentaje, sentido] = fitting_epsilon(param, param_actual, epsilon, l_min, l_max, porcentaje, sentido)
if((param - param_actual > 0) & (sentido == 1))

    l_min = epsilon;

    epsilon = (1 + porcentaje) * epsilon;

    if(epsilon > l_max)
        epsilon = (l_min + l_max)/2;
    end

    sentido = 1;

    porcentaje = 2 * porcentaje;
    return;
end

if((param - param_actual < 0) & (sentido == 1))

    porcentaje = porcentaje / 2;

    if(porcentaje >= 1)
        porcentaje = 0.25;
    end

    l_max = epsilon;

    epsilon = (1 - porcentaje) * epsilon;

    if(epsilon < l_min)
        epsilon = (l_min + l_max)/2;
    end

    sentido = 0;
    return;
end

if((param - param_actual < 0) & (sentido == 0))

    if(porcentaje >= 1)
        porcentaje = 0.25;
    end

    l_max = epsilon;

    epsilon = (1 - porcentaje) * epsilon;

    if(epsilon < l_min)
        epsilon = (l_min + l_max)/2;
    end

    sentido = 0;

    porcentaje = 2 * porcentaje;
    return;
end

if((param - param_actual > 0) & (sentido == 0))

    porcentaje = porcentaje / 2;

    l_min = epsilon;

    epsilon = (1 + porcentaje) * epsilon;

    if(epsilon > l_max)
        epsilon = (l_min + l_max)/2;
    end

    sentido = 1;
    return;
end
