
% sentido = 1 -> Increassing uCP (i.e. increasing the distortion parameter)
% sentido = 0 -> Decreassing uCP (i.e. decreasing the distortion parameter)
% l_min       -> Lower uCP limit
% l_max       -> Upper uCP limit

function [uCP, l_min, l_max, porcentaje, sentido] = fitting_uCP(param, param_actual, uCP, l_min, l_max, porcentaje, sentido)
if((param - param_actual > 0) & (sentido == 1))

    porcentaje = porcentaje / 2;

    if(porcentaje >= 1)
        porcentaje = 0.25;
    end

    l_max = uCP;

    uCP = (1 - porcentaje) * uCP;

    if(uCP < l_min)
        uCP = (l_min + l_max)/2;
    end

    sentido = 0;
    return;
end

if((param - param_actual < 0) & (sentido == 1))

    l_min = uCP;

    uCP = (1 + porcentaje) * uCP;

    if(uCP > l_max)
        uCP = (l_min + l_max)/2;
    end

    sentido = 1;

    porcentaje = 2 * porcentaje;
    return;
end

if((param - param_actual < 0) & (sentido == 0))

    porcentaje = porcentaje / 2;

    l_min = uCP;

    uCP = (1 + porcentaje) * uCP;

    if(uCP > l_max)
        uCP = (l_min + l_max)/2;
    end

    sentido = 1;
    return;
end

if((param - param_actual > 0) & (sentido == 0))

    if(porcentaje >= 1)
        porcentaje = 0.25;
    end

    l_max = uCP;

    uCP = (1 - porcentaje) * uCP;

    if(uCP < l_min)
        uCP = (l_min + l_max)/2;
    end

    sentido = 0;

    porcentaje = 2 * porcentaje;
    return;
end
