
function [Results] = entropy_svr(algoritmo,entropias,Im,epsilon_ini,perfil,K,exponente,directorio,ficherin,N_it)
you_are_here=pwd;

ini_bits = 2.5;
fin_bits = 15;

RMSEs = [];
SSIMs = [];
MPEls = [];
MPEnls = [];
Results = [];

umbral = 0.005;

N = length(Im);
for i = 1:length(entropias)

    ImR = [];
    disp(['Epsilon iteration for desired rate: ' num2str(entropias(i))]);
    for b = ini_bits:0.5:fin_bits

        epsilon = 0;

        bits = b;

        iter = 0;

        no_results = 0;

        porcentaje = 1;

        sentido = 0;

        l_min = 0;
        l_max = 100000;

        entropia_actual = 0;
        while((abs(entropias(i) - entropia_actual) > umbral) && (iter < N_it))
            iter = iter + 1;

            if(iter ~= 1 && iter ~= 2)
                [epsilon,l_min,l_max,porcentaje,sentido] = fitting_epsilon_entropy(entropias(i),entropia_actual,epsilon,l_min,l_max,porcentaje,sentido);
            end

            switch(algoritmo)
                case 1,
                    fichero = [ficherin '_cte_svr_entropy'];
                    svr_dct_encoder(Im,bits,epsilon,K,perfil,directorio,[fichero '_' num2str(i)]);
                case 2,
                    fichero = [ficherin '_robinson03_entropy'];
                    svr_dct_encoder(Im,bits,epsilon,K,perfil,directorio,[fichero '_' num2str(i)]);
                case 3,
                    fichero = [ficherin '_gomez05_entropy'];
                    svr_dct_encoder(Im,bits,epsilon,K,perfil,directorio,[fichero '_' num2str(i)]);
                case 4,
                    fichero = [ficherin '_camps08_entropy'];
                    if exist('RESP','var')
                       RESP=svr_nl_encoder(Im,bits,epsilon,K,exponente,directorio,[fichero '_' num2str(i)],RESP);
                    else
                       RESP=svr_nl_encoder(Im,bits,epsilon,K,exponente,directorio,[fichero '_' num2str(i)]);
                    end
                case 5,
                    fichero = [ficherin '_nl2_svr_entropy'];
                    if exist('RESP','var')
                       RESP=svr_nl_encoder(Im,bits,epsilon,K,exponente,directorio,[fichero '_' num2str(i)],RESP);
                    else
                       RESP=svr_nl_encoder(Im,bits,epsilon,K,exponente,directorio,[fichero '_' num2str(i)]);
                    end
            end

            D = dir([directorio fichero '_' num2str(i) '.zip']);
            tamanyo = 8 * D.bytes;

            entropia_actual = tamanyo / N^2;

            disp(['Iterat:  ' num2str(iter) '   Rate:  ' num2str(entropia_actual) ' bpp   Bits:  ' num2str(bits) '   Epsilon:  ' num2str(epsilon)]);

            if((iter == 1) && (entropias(i) - entropia_actual > 0) && (epsilon == 0))
                disp('Desired entropy is too large to be reached even with Epsilon=0, thus Bits is increased');
                no_results = 1;
                break;

            elseif(iter == 1)

                epsilon = epsilon_ini(i);
            end
        end
        if(no_results == 0)

            cd(directorio)
            unzip([fichero '_' num2str(i) '.zip']);
            switch(algoritmo)
                case 1,
                    ristra = read_code_svr_dct([fichero '_' num2str(i) '.bin']);
                case 2,
                    ristra = read_code_svr_dct([fichero '_' num2str(i) '.bin']);
                case 3,
                    ristra = read_code_svr_dct([fichero '_' num2str(i) '.bin']);
                case 4,
                    ristra = read_code_svr_nl([fichero '_' num2str(i) '.bin']);
                case 5,
                    ristra = read_code_svr_nl([fichero '_' num2str(i) '.bin']);
            end

            delete([fichero '_' num2str(i) '.bin']);

            switch(algoritmo)
                case 1,
                    [ImR] = svr_dct_decoder(K,directorio,[fichero '_' num2str(i)]);
                case 2,
                    [ImR] = svr_dct_decoder(K,directorio,[fichero '_' num2str(i)]);
                case 3,
                    [ImR] = svr_dct_decoder(K,directorio,[fichero '_' num2str(i)]);
                case 4,
                    [ImR] = svr_nl_decoder(K,exponente,directorio,[fichero '_' num2str(i)]);
                case 5,
                    [ImR] = svr_nl_decoder(K,exponente,directorio,[fichero '_' num2str(i)]);
            end

            [RMSEs(i),SSIMs(i),MPEls(i),MPEnls(i)] = computing_distortions(Im,ImR);

            Results(i).Bits = bits;
            Results(i).Epsilon = epsilon;
            Results(i).Kernel = K;
            if(algoritmo == 4 || algoritmo == 5)
                Results(i).Exponente = exponente;
            end
            Results(i).RMSE = RMSEs(i);
            Results(i).SSIM = SSIMs(i);
            Results(i).MPE_linear = MPEls(i);
            Results(i).MPE_non_linear = MPEnls(i);
            Results(i).Entropy = entropia_actual;
            Results(i).Image = ImR;

            ini_bits = b;

            break;
        end
    end
end
cd(you_are_here);
