function [Results] = entropy_ucp(algoritmo,entropias,Im,uCP_ini,exponente,directorio,ficherin,N_it)

you_are_here=pwd;

RMSEs = [];
SSIMs = [];
MPEls = [];
MPEnls = [];
Results = [];

umbral = 0.005;

N = length(Im);
if algoritmo==8
    fprintf('\n');
    disp('Sorry: Epifanio 03 algorithm is not available at the moment (coming soon)')
    Results=0;
else
    for i = 1:length(entropias)

        ImR = [];
        disp(['uCP iteration for desired rate:   ' num2str(entropias(i))]);

        uCP = 0;

        iter = 0;

        no_results = 0;

        porcentaje = 1;

        sentido = 1;

        l_min = 0;
        l_max = 32;

        entropia_actual = 0;
        while((abs(entropias(i) - entropia_actual) > umbral) & (iter < N_it))
            iter = iter + 1;

            if(iter ~= 1 & iter ~= 2)
                [uCP,l_min,l_max,porcentaje,sentido] = fitting_uCP_entropy(entropias(i),entropia_actual,uCP,l_min,l_max,porcentaje,sentido);
            end

            switch(algoritmo)
                case 6,
                    fichero = [ficherin '_jpeg91_entropy'];
                    jpeg91_encoder(Im,uCP,directorio,[fichero '_' num2str(i)]);
                case 7,
                    fichero = [ficherin '_malo99_entropy'];
                    malo99_encoder(Im,uCP,directorio,[fichero '_' num2str(i)]);
                case 8,
                case 9,
                    fichero = [ficherin '_malo06_entropy'];
                    if exist('RESP','var')
                        RESP=malo06_encoder(Im,uCP,exponente,directorio,[fichero '_' num2str(i)],RESP);
                    else
                        RESP=malo06_encoder(Im,uCP,exponente,directorio,[fichero '_' num2str(i)]);
                    end
                case 10,
                    fichero = [ficherin '_malo06_2_entropy'];
                    if exist('RESP','var')
                        RESP=malo06_encoder(Im,uCP,exponente,directorio,[fichero '_' num2str(i)],RESP);
                    else
                        RESP=malo06_encoder(Im,uCP,exponente,directorio,[fichero '_' num2str(i)]);
                    end
            end

            D = dir([directorio fichero '_' num2str(i) '.zip']);
            tamanyo = 8 * D.bytes;

            entropia_actual = tamanyo / N^2;

            disp(['Iterat:  ' num2str(iter) '   Rate:  ' num2str(entropia_actual) ' bpp   uCP:  ' num2str(uCP)]);

            if((iter == 1) & (entropias(i) - entropia_actual < 0) & (uCP == 0))
                disp('The selected entropy is too small to be reached.');
                no_results = 1;
                break;

            elseif(iter == 1)

                uCP = uCP_ini(i);
            end
        end
        if(no_results == 0)

            cd(directorio)
            unzip([fichero '_' num2str(i) '.zip']);
            switch(algoritmo)
                case 6,
                    ristra = read_code_jpeg91([fichero '_' num2str(i) '.bin']);
                case 7,
                    ristra = read_code_malo99([fichero '_' num2str(i) '.bin']);
                case 8,
                case 9,
                    ristra = read_code_malo06([fichero '_' num2str(i) '.bin']);
                case 10,
                    ristra = read_code_malo06([fichero '_' num2str(i) '.bin']);
            end

            delete([fichero '_' num2str(i) '.bin']);

            switch(algoritmo)
                case 6,
                    [ImR] = jpeg91_decoder(directorio,[fichero '_' num2str(i)]);
                case 7,
                    [ImR] = malo99_decoder(directorio,[fichero '_' num2str(i)]);
                case 8,
                case 9,
                    [ImR] = malo06_decoder(exponente,directorio,[fichero '_' num2str(i)]);
                case 10,
                    [ImR] = malo06_decoder(exponente,directorio,[fichero '_' num2str(i)]);
            end

            [RMSEs(i),SSIMs(i),MPEls(i),MPEnls(i)] = computing_distortions(Im,ImR);

            if(algoritmo == 9 | algoritmo == 10)
                Results(i).Exponente = exponente;
            end
            Results(i).RMSE = RMSEs(i);
            Results(i).SSIM = SSIMs(i);
            Results(i).MPE_linear = MPEls(i);
            Results(i).MPE_non_linear = MPEnls(i);
            Results(i).Entropy = entropia_actual;
            Results(i).Image = ImR;
        end
    end
end
cd(you_are_here);
