
% It iterates the algorithm for some distortion values. It fits the
% epsilon and the number of bits, to reach such distortion value.
% It computes the entropies and gives an struct for each distortion value.
%
% Im         -> Original Image
% algoritmo  -> Algorithm.
%               1  -> CTE + SVR
%               2  -> RKi + SVR
%               3  -> CSF + SVR
%               4  -> NL1 + SVR
%               5  -> NL2 + SVR
%               6  -> JPEG91
%               7  -> Malo99
%               8  -> Epifanio03
%               9  -> Malo06_1
%               10 -> Malo06_2
% variable   -> Kind of distorsion to fit:
%               'RMSE', 'SSIM', 'MPE lineal', 'MPE no lineal',
%               'MPE no lineal JMLR'
% distorsiones -> Vector with the distortion values.
% parametro  -> Starting epsilon (for SVR) or starting uCP
% directorio -> String with the path to the folder to save BIN and ZIP files.
%
% USE: [Results] = iter_distortion(Im,algoritmo,variable,distorsiones,parametro,directorio)

function [Results] = iter_distortion(Im,algoritmo,variable,distorsiones,parametro,directorio)
[perfil,K,exponente] = computing_parameters_entropy(algoritmo);
if(algoritmo <= 5)
    Results = distortion_svr(algoritmo,variable,distorsiones,Im,parametro,K,perfil,exponente,directorio);
else
    Results = distortion_ucp(algoritmo,variable,distorsiones,Im,parametro,exponente,directorio);
end