
% It iterates the algorithm for some entropy values. It fits the
% epsilon and the number of bits, to reach such distortion value.
% It computes the distortions and gives an struct for each entropy value.
%
% Im         -> Original Image
% algoritmo  -> Algorithm.
%               1  -> CTE + SVR
%               2  -> RKi + SVR
%               3  -> CSF + SVR
%               4  -> NL1 + SVR
%               5  -> NL2 + SVR
%               6  -> JPEG91
%               7  -> Malo99
%               8  -> Epifanio03
%               9  -> Malo06_1
%               10 -> Malo06_2
% entropias -> Vector with the entropy values.
% parametro  -> Starting epsilon (for SVR) or starting uCP
% directorio -> String with the path to the folder to save BIN and ZIP files.
%
% USE: [Results] = iter_entropy(Im,algoritmo,entropias,parametro,directorio)

function [Results] = iter_entropy(Im,algoritmo,entropias,parametro,directorio)
[perfil,K,exponente] = computing_parameters_entropy(algoritmo);
if(algoritmo <= 5)
    Results = entropy_svr(algoritmo,entropias,Im,parametro,perfil,K,exponente,directorio);
else
    Results = entropy_ucp(algoritmo,entropias,Im,parametro,exponente,directorio);
end