
% Using a '.zip' file, it identify the compression method and applies
% the decoder to recover the image
%
% USE: main_decoder(directorio,fichero)

function ImR = main_decoder(directorio,fichero)
cd(directorio);
if(~isempty(findstr(fichero,'cte_svr')) || ~isempty(findstr(fichero,'robinson03')) || ~isempty(findstr(fichero,'gomez05')))
    K = kernel2d_variance(16,1);
    ImR = svr_dct_decoder(K,directorio,fichero);
elseif(~isempty(findstr(fichero,'camps08')))
    K = kernel2d_variance(16,1);
    exponente = 1;
    ImR = svr_nl_decoder(K,exponente,directorio,fichero);
elseif(~isempty(findstr(fichero,'nl2_svr')))
    K = kernel2d_variance(16,1);
    exponente = 2;
    ImR = svr_nl_decoder(K,exponente,directorio,fichero);
elseif(~isempty(findstr(fichero,'jpeg91')))
    ImR = jpeg91_decoder(directorio,fichero);
elseif(~isempty(findstr(fichero,'malo99')))
    ImR = malo99_decoder(directorio,fichero);
elseif(~isempty(findstr(fichero,'malo06')))
    exponente = 1;
    ImR = malo06_decoder(exponente,directorio,fichero);
elseif(~isempty(findstr(fichero,'malo06_2')))
    exponente = 2;
    ImR = malo06_decoder(exponente,directorio,fichero);
else
    disp('The decoding algorithm cannot be obtained from the file name!');
end