
% It computes RMSE, SSIM, linear MPE, non-linear MPE and non-linear JMLR MPE
% for a distorted image.
%
% Im      -> Original Image
% ImR     -> Distorted Imagen
% pesos   -> Vector with weights for each YUV layer (color images).
% exp_sum -> Pooling exponent (for SCIELab).
%
% In achormatic images, MPE's does not need and extra YUV transform.

function [RMSE,SSIM,MPEl,MPEnlJMLR,SCIELab] = computing_distortions_c(Im,ImR,pesos,exp_sum)
Im = double(Im);
ImR= double(ImR);
if(nargin < 3)
    pesos = [1/3 1/3 1/3];
    exp_sum = 1;
elseif(nargin < 4)
    exp_sum = 1;
end
[Nf Nc N] = size(Im);
RMSEn = zeros(N,1);
SSIMn = zeros(N,1);
RMSE = 0;
SSIM = 0;
MPEl = 0;
MPEnlJMLR = 0;
if(N == 3)

    ImYUV = my_rgb2yuv(double(Im));
    ImRYUV = my_rgb2yuv(double(ImR));
end
for capa = 1:N
    if(N == 3)

        SSIMn(capa) = 0;
    else

        SSIMn(capa) = 0;
    end
end
for i = 1:N

    SSIM = SSIM + pesos(i) * SSIMn(i);
end
RMSE = sqrt( sum((Im(:)-ImR(:)).^2) / numel(Im) );
if((nargout > 4) && (N == 3))
    Im = double(Im);
    ImR = double(ImR);

    SCIELab = 0;
end
