
function jpeg91_c_encoder(Im,normaliz,To,dUmax,dVmax,bits,directorio,fichero,niveles,bitmax)

if(nargin < 11 && niveles == 1)
    bitmax = 1;
end

Im=double(Im);

MM = 1;

if niveles==0

    k = [];
    for canal=1:3
        [ciaf1D,N,iaf] = vqperc_crom_lin_2(16,1,2,0,0,uCP(canal),bitmax,32,canal,0);
        k=[k; N(1:16)];
    end

    M = maxi(k);
    k = k/M;
    bits = log2(M) .* [1 1 1];

else

    opcion = 1;
    Fc = 0;
    Pesos = [1 1 1];
    k = deal_levels(16,64,opcion,Fc,Pesos);

end

Ncuan=4;
tam=size(Im);
if length(tam)==3
    capas=tam(3);
else
    capas=1;
end

tam=tam(1);
lados=[tam tam];
lcuan=tam/(2^Ncuan);

YUV=my_rgb2yuv(double(Im));

for i=1:capas
    dcti(:,:,i)=dct2r(YUV(:,:,i),Ncuan);
end

[dct_contr,Lm]=contras3(dcti,Ncuan,normaliz,To,dUmax,dVmax);

W=1;

val_r=To;

e(:,:,1)=imdpcm(Lm(:,:,1),W,val_r(1));
e(:,:,2)=imdpcm(Lm(:,:,2),W,val_r(2));
e(:,:,3)=imdpcm(Lm(:,:,3),W,val_r(3));

N=round(0.9*[40 10 10]);

for i=1:3
    e1=e(:,:,i);
    me=mini(e1);
    Me=maxi(e1);

    extr_err(:,i)=[me Me]';

    QE(:,:,i)=round((N(i)-1)*(e1-me)/(Me-me));

end

masc=zeros(16,16);
masc(1:8,1:8)=ones(8,8);
masc=repmat(masc,16,16);
dct_contr(:,:,2)=masc.*dct_contr(:,:,2);
dct_contr(:,:,3)=masc.*dct_contr(:,:,3);

   for i=1:3
      qe(:,:,i)=(extr_err(2,i)-extr_err(1,i))*QE(:,:,i)/(N(i)-1)+extr_err(1,i);
      LumQ(:,:,i)=iimdpcm(qe(:,:,i),1,val_r(i));
   end

Lb = lcuan;
Li = tam;

codigazoA=[];
codigazoC1=[];
codigazoC2=[];

codigazoA_eob=[];
codigazoC1_eob=[];
codigazoC2_eob=[];

signosr = zeros(256,255,3);
betasc = zeros(256,255,3);
betascr= zeros(256,255,3);

fprintf('  Quantizing blocks of the local linear domain');

for cap=1:capas
    bloquecito=1;
    for i=1:Lb:Li
        fprintf('.');
        for j=1:Lb:Li

            aa=dct_contr(i:(i+(Lb-1)),j:(j+(Lb-1)),cap);

            [r,alfa2d(:,:,cap)]=respue_lin(aa,k,cap);

            r=zigzag(r);

            azig = zigzag(aa);
            azigsc = azig(2:end);

            bitsig=getsign(azigsc,Lb);
            signosr(bloquecito,:,cap) = bitsig;
            betasc(bloquecito,:,cap) = r(2:end);
            bloquecito=bloquecito+1;
        end
    end
end
fprintf('\n');

signos = zeros(size(signosr));

for cap=1:capas

    NumNiv(cap) = 2^bits(cap);

    betascr(:,:,cap) = round( NumNiv(cap) * betasc(:,:,cap)/MM)*MM/NumNiv(cap);

    rc=betascr(:,:,cap);

    sinnos=signosr(:,:,cap);
    sinnos(logical(abs(rc)>0))=sinnos(logical(abs(rc)>0));
    signos(:,:,cap)=sinnos;

    if cap==1
        codigonA(:,:,cap) = betascr(:,:,cap).*(~signosr(:,:,cap)) - betascr(:,:,cap).*(signosr(:,:,cap));
        codigonAint(:,:,cap)=codigonA*NumNiv(cap)/MM;

        for i=1:Lb^2
            [cod,ceros]=rle2(codigonAint(i,:,cap));

            codigazoA_eob=[codigazoA_eob cod ceros 1e8];
            codigazoA=[codigazoA cod ceros];
        end

    else
        codigonCcompleto(:,:,cap-1)=betascr(:,:,cap).*(~signosr(:,:,cap)) - betascr(:,:,cap).*(signosr(:,:,cap));
        codigonCintcompleto(:,:,cap-1)=codigonCcompleto(:,:,cap-1)*NumNiv(cap)/MM;

        for i=1:Lb^2
            bet=betascr(i,:,cap).*(~signosr(i,:,cap)) - betascr(i,:,cap).*(signosr(i,:,cap));
            bet=dezigzag([0 bet]);
            bet=bet(1:8,1:8);
            bet=zigzag(bet);
            codigonC(i,:,cap-1)=bet(2:end);
            codigonCint(i,:,cap-1)=codigonC(i,:,cap-1)*NumNiv(cap)/MM;

            [cod,ceros]=rle2(codigonCint(i,:,cap-1));

            if cap==2
                codigazoC1_eob=[codigazoC1_eob cod ceros 1e8];
                codigazoC1=[codigazoC1 cod ceros];
            else
                codigazoC2_eob=[codigazoC2_eob cod ceros 1e8];
                codigazoC2=[codigazoC2 cod ceros];
            end
        end
    end

end

ristra = [extr_err(:)' round(QE(:))' bits round(codigazoA) round(codigazoC1) round(codigazoC2)];

cd(directorio);
save_code(ristra,[fichero '.bin']);

zip(fichero,[fichero '.bin']);

delete([fichero '.bin']);
