% IAFRG calculated values ​​of the function of allocation of information
% for the RG (experim) channel in the discrete frequency domain and
% contrasts defined by row vectors (f, C)
%-of lengths m and n respectivelly-
%
% IAFRG gives an m * n array such that each row contains the values
% of the function for different contrasts (with fixed f)
%
%
% USE: [iafrg,csfrg] = iafrg(f,C,facfrec,[aplic_no_lineal?(0/1) ciaf_no_lin? aplic_log?]);
%

function [iaf,csfrg]=iafrg(f,C,facfrec,nolin)

f=facfrec*f;

f=f+0.00001*(f==0);
C=C+0.0000001*(C==0);

lf=length(f);
lc=length(C);

iaf=zeros(lf,lc);
p=[0.0840 0.8345 0.6313 0.2077];

if length(nolin)==1
   nolin=[nolin nolin];
end

nolini=nolin;
nolin=nolini(1);

if ((nolini(1)==0)&(nolini(2)==1))
   nolin=1;
end

if nolin==1
   for i=1:lf
       cu=1/(100*2537.9*sigm1d(f(i),-55.94,6.64));
       ace(i,:)=umbinc3(C,cu,p(1),p(2),p(3),p(4));
   end
   iaf=1./ace;
else
   iaf=100*2537.9*sigm1d(f,-55.94,6.64);
   iaf=iaf'*ones(1,length(C));
end
csfrg=iaf(:,1)';

if ((nolini(1)==0)&(nolini(2)==1))
   s=size(iaf);
   iafc=sum(iaf')';
   iaf=iafc*ones(1,s(2));
end

