
% MY_YUV2RGB computes the true color image RGB given a true color YUV image by
% using the matrix:
%
%   Myuv_rgb =
%
%    1.0000    0.0000    1.3707
%    1.0000   -0.3365   -0.6982
%    1.0000    1.7324    0.0000
%
% MY_RGB2YUV is its inverse
%
% USE: RGB=my_yuv2rgb(YUV);

function RGB=my_yuv2rgb(YUV);

Mrgb_yuv =[0.2990    0.5870    0.1140;-0.1726   -0.3388    0.5114;0.5114   -0.4282   -0.0832];
Myuv_rgb = inv(Mrgb_yuv);

YUV=double(YUV);
RGB=YUV;

RGB(:,:,1)=Myuv_rgb(1,1)*YUV(:,:,1)+Myuv_rgb(1,2)*YUV(:,:,2)+Myuv_rgb(1,3)*YUV(:,:,3);
RGB(:,:,2)=Myuv_rgb(2,1)*YUV(:,:,1)+Myuv_rgb(2,2)*YUV(:,:,2)+Myuv_rgb(2,3)*YUV(:,:,3);
RGB(:,:,3)=Myuv_rgb(3,1)*YUV(:,:,1)+Myuv_rgb(3,2)*YUV(:,:,2)+Myuv_rgb(3,3)*YUV(:,:,3);
