% RESPUE_LIN calculates the linear response to local DCT2D (expressed in contrast)
% of the YUV (or ATD) simulating the linear channel detector response SVH frequency.
%
%   DCTn(f) = k1(f) DCT(f)
%
% where k1 is the CSF.
%
% Outputs:
%
%  Resp = response
%  kk1 = parameter k1 in matrix shape
%
% USE:
%
% [Resp,kk1] = respue_lin(dctinic,k1,canal)
%

function [R,alfa]=respue_lin(dctinic,k,canal)

tam=size(dctinic);
tam=tam(1);
lados=[tam tam];

lcuan=lados(1);

k1=k(canal,:);

k1=simrev(k1);
k1=zigzag(k1);

alfa=k1;

cub=dctinic;

cub=zigzag(cub);

cub=abs(cub);

R=k1.*cub;
R=dezigzag(R);
