
% It iterates the algorithm for some entropy values. It fits the
% uCP, to reach such distortion value.
% It computes the distortions and gives an struct for each entropy value.
%
% Im         -> Original Image
% normaliz   -> Contrast Normalization
% To         ->
% dUmax      ->
% dVmax      ->
% uCPv       -> Initial uCP value
% niveles    -> Number of quantization levels
% entropias  -> Vector with the entropy values
% directorio -> String with the path to the folder to save BIN and ZIP files.
% fichero    -> String with the name of BIN and ZIP files.
%
% NOTE THAT: 'entropias' has to be sorted ascent

function [Results_JPEG] = entropy_jpeg(Im,normaliz,To,dUmax,dVmax,uCPv,entropias,directorio,fichero,num_iter,niveles,bitmax)
you_are_here=pwd;

if(nargin < 12 && niveles == 1)
    bitmax = 1;
end

exp_sum = 1:2;

RMSEs = [];
SSIMs = [];
MPEls = [];
MPEnls = [];
MPEnlJMLRs = [];
SCIELabs = zeros(length(entropias),length(exp_sum));
Results_JPEG = [];
uCPs = zeros(length(entropias),3);

umbral = 0.005;

N = 256;

pesoY = 0.7;
pesoU = 0.15;
pesoV = 0.15;
for i = 1:length(entropias)

    uCP = [0 0 0];

    iter = 0;

    porcentaje = 1;

    sentido = 1;

    l_min = 0;
    l_max = 100000;

    ImR_JPEG = [];

    entropia_actual = 0;
    disp(['Modifying quantization coarsenes to obtain the target entropy:   ' num2str(entropias(i))]);
    while((abs(entropias(i) - entropia_actual) > umbral) && (iter <= num_iter))
        iter = iter + 1;

        if(iter ~= 1 && iter ~= 2)
            [uCP2,l_min,l_max,porcentaje,sentido] = fitting_uCP_entropy(entropias(i),entropia_actual,uCP(1),l_min,l_max,porcentaje,sentido);
            uCP = uCP2 .* [1 1 1];
        end

        jpeg91_c_encoder(Im,normaliz,To,dUmax,dVmax,uCP,directorio,[fichero '_jpeg91_c_entropy_' num2str(i)],niveles);

        D = dir([directorio fichero '_jpeg91_c_entropy_' num2str(i) '.zip']);
        tamanyo = 8 * D.bytes;

        entropia_actual = tamanyo / N^2;

        disp(['Iterat:  ' num2str(iter) '   Entropy:  ' num2str(entropia_actual) '   Control Paramet:  ' num2str(uCP(1))]);

        if((iter == 1) && (entropias(i) - entropia_actual < 0) && (uCP(1) == 0))
            disp('Target entropy is too small to be reached even discarding all AC coefficients');
            break;

        elseif((iter == 1) && (abs(entropias(i) - entropia_actual) <= umbral) && (uCP(1) == 0))

            if(i ~= 1)

                uCP = uCPs(i-1,:);

            else

                uCP = uCPv(i,:);
            end

            entropia_actual = 0;

        elseif(iter == 1)

            if(i ~= 1)

                uCP = uCPs(i-1,:);

            else

                uCP = uCPv(i,:);
            end
        end
    end

    uCPs(i,:) = uCP;

    cd(directorio)
    unzip([fichero '_jpeg91_c_entropy_' num2str(i) '.zip']);
    ristra = read_code([fichero '_jpeg91_c_entropy_' num2str(i) '.bin']);

    delete([fichero '_jpeg91_c_entropy_' num2str(i) '.bin']);

    ImR_JPEG = jpeg91_c_decoder(normaliz,To,dUmax,dVmax,directorio,[fichero '_jpeg91_c_entropy_' num2str(i)],niveles);

    [RMSEs(i),SSIMs(i),MPEls(i),MPEnlJMLRs(i),SCIELabs(i,:)] = computing_distortions_c(Im,ImR_JPEG,[pesoY pesoU pesoV],exp_sum);

    Results_JPEG(i).Normalizacion = normaliz;
    Results_JPEG(i).To = To;
    Results_JPEG(i).dUmax = dUmax;
    Results_JPEG(i).dVmax = dVmax;
    Results_JPEG(i).Niveles = niveles;
    Results_JPEG(i).RMSE = RMSEs(i);
    Results_JPEG(i).SSIM = SSIMs(i);

    for n = 1:length(exp_sum)
        eval(['Results_JPEG(i).SCIELab_exp' num2str(exp_sum(n)) ' = SCIELabs(i,n);']);
    end
    Results_JPEG(i).Entropy = entropia_actual;
    Results_JPEG(i).uCP = uCPs(i,:);
    Results_JPEG(i).Image = ImR_JPEG;
    Results_JPEG(i).ristra = ristra;
end
cd(you_are_here);
