
% It iterates the algorithm for some entropy values. It fits the
% epsilon and number of bits, to reach such distortion value.
% It computes the distortions and gives an struct for each entropy value.
%
% Im         -> Original Image
% normaliz   -> Contrast Normalization
% To         ->
% dUmax      ->
% dVmax      ->
% epsilonv   -> Starting epsilon
% Bits_inic  -> Starting Bits
% K          -> RBF Kernel
% exponente  -> Pooling exponent for the non-linear model
% tipo_alfa  -> CSF profile
% entropias  -> Vector with the entropy values
% directorio -> String with the path to the folder to save BIN and ZIP files.
% fichero    -> String with the name of BIN and ZIP files.
%
% NOTE THAT: 'entropias' has to be sorted ascent

function [Results_NL_SVR] = entropy_nl_svr(Im,normaliz,To,dUmax,dVmax,epsilonv,bits_inic,K,exponente,tipo_alfa,entropias,directorio,fichero,num_iter)
you_are_here=pwd;

exp_sum = 1:2;

RMSEs = [];
SSIMs = [];
MPEls = [];
MPEnls = [];
MPEnlJMLRs = [];
SCIELabs = zeros(length(entropias),length(exp_sum));
Results_NL_SVR = [];
epsilons = zeros(length(entropias),3);

umbral = 0.005;

N = 256;

pesoY = 0.7;
pesoU = 0.15;
pesoV = 0.15;

fin_bits = 15;
for i = 1:length(entropias)
    ini_bits = bits_inic(i);

    ImR_NL_SVR = [];
    disp(['Modifying SVM insensitivity to achieve the target entropy:   ' num2str(entropias(i))]);
    for b = ini_bits:0.5:fin_bits

        epsilon = [0 0 0];

        bits = b .* [1 1 1];

        iter = 0;

        no_results = 0;

        porcentaje = 1;

        sentido = 0;

        l_min = 0;
        l_max = 100000;

        entropia_actual = 0;
        while((abs(entropias(i) - entropia_actual) > umbral) && (iter <= num_iter))
            iter = iter + 1;

            if(iter ~= 1 && iter ~= 2)
                [epsilon2, l_min, l_max, porcentaje, sentido] = fitting_epsilon_entropy(entropias(i), entropia_actual, epsilon(1), l_min, l_max, porcentaje, sentido);
                epsilon = epsilon2 .* [1 1 1];
            end

            if exist('RESP','var')
               RESP=svr_nl_c_encoder_cs(Im,normaliz,To,dUmax,dVmax,bits,epsilon,K,exponente,tipo_alfa,directorio,[fichero '_gutierrez09_c_entropy_' num2str(i)],RESP);
            else
               RESP=svr_nl_c_encoder_cs(Im,normaliz,To,dUmax,dVmax,bits,epsilon,K,exponente,tipo_alfa,directorio,[fichero '_gutierrez09_c_entropy_' num2str(i)]);
            end
            close all

            D = dir([directorio fichero '_gutierrez09_c_entropy_' num2str(i) '.zip']);
            tamanyo = 8 * D.bytes;

            entropia_actual = tamanyo / N^2;

            disp(['Iterat:  ' num2str(iter) '   Entropy:  ' num2str(entropia_actual) '   Bits:  ' num2str(bits(1)) '   Epsilon:  ' num2str(epsilon(1))]);

            if((iter == 1) && (entropias(i) - entropia_actual > 0) && (epsilon(1) == 0))
                disp('Desired entropy is too large to be reached even with Epsilon=0, thus Bits is increased');
                no_results = 1;
                break;

            elseif((iter == 1) && (abs(entropias(i) - entropia_actual) <= umbral) && (epsilon(1) == 0))

                epsilon = epsilonv(i,:);

                entropia_actual = 0;

            elseif(iter == 1)

                epsilon = epsilonv(i,:);
            end
        end
        if(no_results == 0)

            epsilons(i,:) = epsilon;

            cd(directorio)
            unzip([fichero '_gutierrez09_c_entropy_' num2str(i) '.zip']);
            ristra = read_code([fichero '_gutierrez09_c_entropy_' num2str(i) '.bin']);

            delete([fichero '_gutierrez09_c_entropy_' num2str(i) '.bin']);

            ImR_NL_SVR = svr_nl_c_decoder_cs(normaliz,To,dUmax,dVmax,K,exponente,tipo_alfa,directorio,[fichero '_gutierrez09_c_entropy_' num2str(i)]);

            [RMSEs(i),SSIMs(i),MPEls(i),MPEnlJMLRs(i),SCIELabs(i,:)] = computing_distortions_c(Im,ImR_NL_SVR,[pesoY pesoU pesoV],exp_sum);

            Results_NL_SVR(i).Normalizacion = normaliz;
            Results_NL_SVR(i).To = To;
            Results_NL_SVR(i).dUmax = dUmax;
            Results_NL_SVR(i).dVmax = dVmax;
            Results_NL_SVR(i).Bits = bits(1);
            Results_NL_SVR(i).Epsilon = epsilon;
            Results_NL_SVR(i).Kernel = K;
            Results_NL_SVR(i).Exponente = exponente;
            Results_NL_SVR(i).Tipo_alfa = tipo_alfa;
            Results_NL_SVR(i).RMSE = RMSEs(i);
            Results_NL_SVR(i).SSIM = SSIMs(i);

            for n = 1:length(exp_sum)
                eval(['Results_NL_SVR(i).SCIELab_exp' num2str(exp_sum(n)) ' = SCIELabs(i,n);']);
            end
            Results_NL_SVR(i).Entropy = entropia_actual;
            Results_NL_SVR(i).Image = ImR_NL_SVR;
            Results_NL_SVR(i).ristra = ristra;

            ini_bits = b;

            break;
        end
    end
end
cd(you_are_here)
