% fs = Sampling frequency
% M  = block size (and operator size)
%
% function opCSF = operatorCSF(fs,M);
%

function opCSF = operatorCSF(fs,M);

[fx,fy]=freqspace(M,'meshgrid');

Fx=fx*fs/2;

Fy=fy*fs/2;

F=sqrt(Fx.^2+Fy.^2);

f=zigzag(F);

[IAF,CSF]=iafet(f,1,0,0,[0 0 0],0);

CSF = dezigzag(CSF);

operador = 1./CSF;

opCSF = ifftshift(operador);

opCSF(1,1)=0;

opCSF = opCSF/max(max(opCSF));

