
% costerespfour computes the coefficients in the Fourier domain using the regularization operator.
% The function returns the inverse of the response to the transform coefficients in the block. To do this,
% the function uses a threshold parameter called "umbral" to set the minimum response value:
%
% USAGE: C = costerespfour(bloque,ladobloque,H,k1,k2,umbral);
%        The nonlinear model considers neighbour interactions (H is this non-diagonal)
%

function F=costeinvrespfour(observado,lcuan,H,k1,k2,umbral);

C=responsefourier(observado,lcuan,H,k1,k2);

C(lcuan/2+1,lcuan/2+1) = 1;
F = C.*( C > umbral ) + umbral.*( C <= umbral );

F=1./F;

F = F/max(max(F));

F(lcuan/2+1,lcuan/2+1) = 1;

