% function mr = maximum_response(observado,M,H,k1,k2,Nbloques);
%
%  It is employed in costeinvrespfour to obtain the response maximum
%  for a bunch of blocks.
%  This maximum is employed to set the breack to compute the response inverse
%  para establecer el corte al hacer la inversa de la respuesta.
%
%   obsevado: Image
%   M: block size
%   H: Interaction function (it is obtained with constantes_sin_continua)
%   k1: alpha (it is obtained with constantes_sin_continua)
%   k2: beta (it is obtained with constantes_sin_continua)
%   Nbloques: Number of blocks to obtain the response
%
%

function mr = maximum_response(observado,M,N,H,k1,k2,Nbloques);

[fil,col]=size(observado);

r=zeros(M);

filas = round(M/2 + rand(Nbloques,1)*(fil-M));
columnas = round(M/2 + rand(Nbloques,1)*(col-M));

for i=1:Nbloques

   bl=observado(filas(i)-M/2+1:filas(i)+M/2,columnas(i)-M/2+1:columnas(i)+M/2);

   r = r+ responsefourier(bl,M,H,k1,k2);

end

respuestamedia = r/Nbloques;

mr = max(max(respuestamedia));
