% function [objeto]=regu_model_ar8(Imobservada,b,lambdas,N,M,criterio_lambda,pinta);
%
%   Given an observed degraded image (given by a PSF and additive noise)
%   it regularizes the using Wiener, from the spectrum estimation
%   modeling the signal using an autorregresive model.
%
%      EXAMPLE
%
%      [Irest_AR8]=regu_model_ar8(BlurredNoisy,PSF,lambdas,N,M,criterio_lambda,pinta);
%

function [restaurada]=regu_model_ar8(Imobservada,b,lambdas,N,M,criterio_lambda,pinta);

[dummy,noiseest]=wiener2(Imobservada,[3 3]);

[fil,col]=size(Imobservada);

nver = fil/N;
nhor = col/N;

objetoparaoverlapping = rand(nver*M,nhor*N);

restaurada=rand([fil,col]);

a=(M-N)/2;

Im2=ampliaconborde(Imobservada,a);

nlamb=length(lambdas);

B=freqz2(b,M,M);

B=ifftshift(B);

contadorfilas=0;

for i=N/2:N:fil

   contadorfilas = contadorfilas+1;
   contadorcolumnas = 0;

   for j=N/2:N:col

      contadorcolumnas = contadorcolumnas + 1;

      observado=Im2(i+a-M/2+1:i+a+M/2,j+a-M/2+1:j+a+M/2);

      cub=fft2(observado);

      [PSD,operador,coef_ar] = fit_it_block_ar8(observado);

      [sol]=restaura_block(observado,B,operador,M,N,lambdas,criterio_lambda);

      restaurada(i-N/2+1:i+N/2,j-N/2+1:j+N/2)=sol(a+1:a+N,a+1:a+N);

      if (pinta==1)
         imshow(restaurada,[0 256],'notruesize'),pause(0.2);
      end

      objetoparaoverlapping((contadorfilas-1)*M+1:contadorfilas*M,(contadorcolumnas-1)*M+1:contadorcolumnas*M) = sol;

   end
end

restaurada = do_overlap(objetoparaoverlapping,M,N,8);

