% function [objeto] = regu_naive(Imobservada,b,N,M);
%
%   Given an observed degraded image (given by 'b' and additive noise)
%   it regularizes using the pseudoinverse in the frequency domain.
%   N is the block size and M is the block size plus the boundary
%   (in order to avoid boundary effects in the reconstruction.
%   It gives back also the image blocks in order to perform the overlapping.
%
%      i.e.
%      N = 16;
%      M = 44;
%      val = 0.1;
%
%      figure,[Irest] = regu_naive(BlurredNoisy,PSF,N,M);

function [restaurada]=regu_naive(Imobservada,b,N,M);

[fil,col]=size(Imobservada);

objeto=rand([fil,col]);

nver = fil/N;
nhor = col/N;

objetoparaoverlapping = rand(nver*M,nhor*N);

a=(M-N)/2;

Im2=ampliaconborde(Imobservada,a);

B=freqz2(b,M,M);

B=ifftshift(B);

BB = abs(B).^2;
Bconj = conj(B);

contadorfilas=1;

for i=M/2:N:fil+a
   i
   contadorcolumnas=1;
   for j=M/2:N:col+a

      observado=Im2(i-M/2+1:i+M/2,j-M/2+1:j+M/2);

      cub=fft2(observado);

      Hinv=Bconj./BB;

      fftsol = Hinv.*cub;

      sol=real(ifft2(fftsol));

      solefectiva=sol(a+1:a+N,a+1:a+N);

      objeto(i-a-N/2+1:i-a+N/2,j-a-N/2+1:j-a+N/2)=solefectiva;

      objetoparaoverlapping((contadorfilas-1)*M+1:contadorfilas*M,(contadorcolumnas-1)*M+1:contadorcolumnas*M) = sol;

      contadorcolumnas=contadorcolumnas+1;
   end
   contadorfilas=contadorfilas+1;
end

restaurada = do_overlap(objetoparaoverlapping,M,N,4);

