% function [objetooverlapping,restaurada,lambdasoptimas]=regu_perceptual(Imobservada,b,lambdas,N,M,H,k1,k2,umbral,criterio_lambda,pinta);
%
%   Given an observed degraded image (given by 'K' and additive noise)
%   it regularizes using the a penalization operator L and reguilarization parameter
%   'lambdas'.
%   N is the block size and M is the block size plus the boundary
%   (in order to avoid boundary effects in the reconstruction.
%
%     i.e.
%     N=16;
%     M=32;
%     [H,k1,k2]=constantes2(fs,M);
%     Nlambdas=70;
%     lambdas=logspace(-2,2,Nlambdas);
%
%     figure,[IrestPinv,lamboptPinv]=regu_perceptual(BlurredNoisy,PSF,lambdas ,N,M,H,k1,k2,umbral,2,1);

function [restaurada,lambdamedio]=regu_perceptual(Imobservada,b,lambdas,N,M,H,k1,k2,umbral,criterio_lambda,pinta);

[fil,col]=size(Imobservada);

nver = fil/N;
nhor = col/N;

objetoparaoverlapping = rand(nver*M,nhor*M);

restaurada=rand([fil,col]);

a=(M-N)/2;

Im2=ampliaconborde(Imobservada,a);

[fil2,col2]=size(Im2);

nlamb=length(lambdas);

B=freqz2(b,M,M);
B=ifftshift(B);

BB = abs(B).^2;
Bconj = conj(B);

energB = sum(sum(abs(B).^2));

contadorfilas=0;

valorlambda=0;

lam=[];

r=zeros(M);

Nbloques = 30;

rand('seed',1)
filas = round(N/2 + rand(Nbloques,1)*(fil-N));
rand('seed',1)
columnas = round(N/2 + rand(Nbloques,1)*(col-N));

lamb = 0;

for i=1:Nbloques

   observado=Im2(filas(i)+a-M/2+1:filas(i)+a+M/2,columnas(i)+a-M/2+1:columnas(i)+a+M/2);

   r = r+ responsefourier(observado,M,H,k1,k2);

end

respuestamedia = r/Nbloques;

maximo = max(max(respuestamedia));

for i=N/2:N:fil

   contadorfilas = contadorfilas+1;
   contadorcolumnas = 0;

   for j=N/2:N:col

      contadorcolumnas = contadorcolumnas + 1;

      observado=Im2(i+a-M/2+1:i+a+M/2,j+a-M/2+1:j+a+M/2);

      F=costeinvrespfour(observado,M,H,k1,k2,maximo/umbral);

      [sol,lambd]=restaura_block(observado,B,F,M,N,lambdas,criterio_lambda);

      lam=[lam lambd];

      restaurada(i-N/2+1:i+N/2,j-N/2+1:j+N/2)=sol(a+1:a+N,a+1:a+N);

      if (pinta == true)
         figure(500),imshow(restaurada,[0 256],'notruesize'),pause(0.2);
      end

      objetoparaoverlapping((contadorfilas-1)*M+1:contadorfilas*M,(contadorcolumnas-1)*M+1:contadorcolumnas*M) = sol;

   end
end

lambdamedio = mean(lam);

restaurada = do_overlap(objetoparaoverlapping,M,N,8);

