% function [sol]=restaura_block(observado,B,F,lambdas,criterio_lambda)
%
%   observado:   block
%   B:           blurring operator in Fourier
%   F:           regularization operator in Fourier
%   lambdas:     vector with the lambda values
%   criterio_lambda:  selectiong lambda method
%
%   It gives back
%   sol:         Restored block

function [sol,valorlambda]=restaura_block(observado,B,F,M,N,lambdas,criterio_lambda)

M = size(observado,1);

nlamb=length(lambdas);

rand('seed',1)
vectorsol = rand(nlamb*M,M);

[dummy,varianzaruido] = wiener2(observado,[2 2]);

energB = sum(sum(abs(B).^2));

Bconj = conj(B);

BB = B.*Bconj;

operador = format_operator(F);

F = operador;

energF = sum(sum(abs(F).^2));

if (energF==0)
   F = sqrt(energB)*F;
else
   F = sqrt(energB)*F/sqrt(energF);
end

FF = F.*conj(F);

ang = linspace(0,pi/2,5);
v = [reverse(cos(ang)) ones(1,M-2*5) cos(ang)];
pesos = v'*v;

observado = observado.*pesos + (1-pesos).*mean(mean(observado));

cub=fft2(observado);

espdeg = cub;

x=zeros(nlamb,1);
y=zeros(nlamb,1);

for k=1:nlamb

   lambda=lambdas(k);

   Hinv=Bconj./( BB + lambda^2*FF);

   fftsol = Hinv.*cub;

   rF = B.*fftsol - cub;

   x(k) = norm(rF(:))/M;

   pF = F.*fftsol;

   y(k)=norm(pF(:))/M;

end

if (nlamb==1)
   valorlambda=lambda;
else
   valorlambda = seleccion_lambda(x,y,lambdas,varianzaruido,criterio_lambda);
end

if (length(valorlambda)>1)
   valorlambda = 2;
end

distancias = abs(lambdas-valorlambda);
pos = find(distancias==min(distancias));
pos = pos(1);

Hinv=Bconj./( BB + valorlambda^2*FF);

sol=real(ifft2(Hinv.*cub));

