% function lamb=estima_lambda(Imobservada,B,lambdas,M,F,Nbloques);
%
%
%   Given an observed degraded image (given by 'K' and additive noise)
%   , it regularizes using the a penalization operator F and reguilarization parameter
%   'lambdas'.
%   N is the block size and M is the block size plus the boundary
%   (in order to avoid boundary effects in the reconstruction.
%   It gives back also the image blocks in order to perform the overlapping.
%
%   i.e.
%
%      N=16;
%      M=44;
%      Nlambdas=70;
%      lambdas=logspace(-2,2,Nlambdas);
%      operador=fft2(filt2dsegder,M,M);
%
%      figure,lamb=estima_lambda(BlurredNoisy,PSF,lambdas,M,operador,Nbloques);
%

function lamb=estima_lambda(Imobservada,B,lambdas,M,N,F,Nbloques);

[fil,col]=size(Imobservada);

a=(M-N)/2;

Im2=ampliaconborde(Imobservada,a);

filas = round(N/2 + rand(Nbloques,1)*(fil-N));
columnas = round(N/2 + rand(Nbloques,1)*(col-N));

filas,columnas

lamb = 0;

for i=1:Nbloques

      observado=Im2(filas(i)+a-M/2+1:filas(i)+a+M/2,columnas(i)+a-M/2+1:columnas(i)+a+M/2);

      [sol,lambda]=restaura_block(observado,B,F,M,N,lambdas,2);

      lamb = lamb + lambda;

end

lamb = lamb / Nbloques;

 
