% This function determines the maximum angular slope variation in the
% L-curve
%
% lambda=max_incr_pend_Lcurva(r,Lx,lambdas)

function regu=max_incr_pend_Lcurva(x,y,lambdas)

if (size(x,1)<size(x,2))
   x=x';
   y=y';
end

xx=linspace(min(x),max(x),25000);

h= xx(2)-xx(1);

try
yy = interp1(x,y,xx,'cubic');

pendientes = diff(yy)/h;

angulos = atan(pendientes)*180/pi;

angulos = (angulos<=-(85))*(-85) + (angulos>=(-10))*(-10) + angulos.*(angulos>(-85) & angulos<(-10));

a=diff(angulos);

mc=find(a==max(max(a)));

regu = interp1(x,lambdas',xx(mc),'cubic');

catch
regu = 2;
end
