
fc = 45;

clc;
echo off;

if (isempty(who('Id')))
   disp('To run this script there should be an image named Id in the workspace.');
   disp('Id should contain the degraded image.');
   disp('apply_degradation.m  can be used to simulate several degradations');
   disp('For instace:');
   disp('    load barbara256');
   disp('    [Id,PSF]=apply_degradetion(Im,''blur_gn'',0.3,400);');
   return;
end

Val_min = 0.001;

lim_frec = [0 3];

vari = 400;

[W,PSF,H,noise,Blurred]=degrade2(rand(256),fc,Val_min,lim_frec,vari);

Nlambdas = 1;
lambdas = 4;

disp(['Restoring image using L2 (' num2str(Nlambdas) ' values of lambda)']);

imrl2=restore(Id,'L2',PSF,lambdas);

figure;
imshow(imrl2/255);
title('Restored (L2)');

disp('Press any key...');
pause;

disp(['Restoring image using CSF (' num2str(Nlambdas) ' values of lambda)']);

imrcsf=restore(Id,'CSF',PSF,lambdas);

figure;
imshow(imrcsf/255);
title('Restored (CSF)');

disp('Press any key...');
pause;

disp(['Restoring image using AR4 (' num2str(Nlambdas) ' values of lambda)']);

imrar4=restore(Id,'AR4',PSF,lambdas);

figure;
imshow(imrar4/255);
title('Restored (AR4)');

disp('Press any key...');
pause;

disp(['Restoring image using AR8 (' num2str(Nlambdas) ' values of lambda)']);

imrar8=restore(Id,'AR8',PSF,lambdas);

figure;
imshow(imrar8/255);
title('Restored (AR8)');

disp('Press any key...');
pause;

disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);

imrar12=restore(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title('Restored (AR12)');

disp('Press any key...');
pause;

disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);

imrper=restore(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title('Restored (PERCEPTUAL)');


