% Method to 'clean' an image using hard-thresholding in the
% steerable wavelet domain (4 scales 8 orientations)
%
% The lambda parameter has been fitted using 100 images for
% variances between [200 - 400], it will not be optimal for different variances
%
% USE: IMM=hard_steerable(Im2,Var)
% Var is the noise variance

function IMM=hard_steerable(Im2,Var)
res= 0.7+sqrt(Var)*0.018;
[pyr,ind]=buildsfpyr(Im2,4,7);
pyr2=abs(pyr);
pyr_sg=sign(pyr);
load indices_epsilon_4esc_8ori
indices=indices*sqrt(Var)/sqrt(400);
res=res*indices;
P2=zeros(size(pyr2));
for k=1:length(pyr2)-255
    if pyr2(k)>res(k)
        P2(k)=pyr2(k)-res(k);
    else
        P2(k)=0;
    end
end
P2(1:256*256-1)=zeros;
P2(end-255:end)=pyr(end-255:end);
PYR3=P2.*pyr_sg;

IMM=reconsfpyr(PYR3,ind);
