%
%   imagenes is a cell containing the image names
%
%   histograma: wavelet coeficients histogram
%   valores:    histograma abscise
%   subbanda:   subband coefficeints
%   subbandacrop:  subband coefficeints without outlayers
%
%   USE: [histograma,valores,subbanda,subbandacrop]=marginal(imagenes,1,'H',256);

function [histograma,valores,subbanda,subbandacrop]=marginal_2(Im,escala,orientacion,bins);

switch lower(orientacion)
   case 'h'
      sub=1;
   case 'v'
      sub=2;
   case 'd'
      sub=3;
end

subbanda=[];

   [pyr,ind]=buildWpyr(double(Im),4);
   pyrsub = wpyrBand(pyr, ind, escala, sub);
   pyrsub = pyrsub(:);
   subbanda = [subbanda; pyrsub];

[histograma,valores] = hist(subbanda,256);
histograma = histograma/sum(histograma);

cdf = cumsum(histograma);

ind1 = find(cdf>=0.005);
ind1 = ind1(1);

ind2 = find(cdf<=0.995);
ind2 = ind2(end);

subbandacrop = subbanda(subbanda>valores(ind1) & subbanda<valores(ind2));

[histograma,valores] = hist(subbanda,256);
histograma = histograma/sum(histograma);
